/* 
* Copyright (C) 2024 Dominik Meyer
*  
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*  
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*  
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include <Redmine-CLI/Command/Version.hpp>
#include <Redmine-CLI/Redmine.hpp>
#include "Redmine/User.hpp"
#include "config.hpp"
#include <iostream>

Command::Version::Version(RedmineCLI::Redmine *r)
:
redmine_(r),
version_(nullptr)
{

    version_ = redmine_->getCLI().add_subcommand("version", "Print current program version");
    version_->callback( [&](){
        std::cout << "redmine-api-client Version " << PROJECT_VERSION << std::endl;
    });



}