/* 
* Copyright (C) 2024 Dominik Meyer
*  
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*  
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*  
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "Redmine-CLI/Redmine.hpp"
#include <CLI/App.hpp>
#include <CLI/Option.hpp>
#include <Redmine/API.hpp>
#include <Redmine/Exception/Api.hpp>
#include <cstdlib>
#include <string>
#define LOGURU_WITH_STREAMS 1
#include <loguru.hpp>
#include <CLI/CLI.hpp>

int main(int argc, char **argv)
{

    
    try {
        CLI::App app("A command line client for the redmine project management server");
        RedmineCLI::Redmine redmineCli{app};
        CLI11_PARSE(app, argc, argv);
    } catch (const std::exception &e) 
    {
        return EXIT_FAILURE;
    }


    
}