#include <Redmine/Issue.hpp>
#define LOGURU_WITH_STREAMS 1
#include <loguru.hpp>


Redmine::Issue::Issue(const nlohmann::json &issue) : Redmine::Object()
{
    set(issue);
}

void Redmine::Issue::set(const nlohmann::json &data)
{
    _verify(data);
    data_=data;
}

nlohmann::json Redmine::Issue::get() const 
{
    return data_;
}

void Redmine::Issue::_verify(const nlohmann::json &data)
{
    
    _baseVerify(data, "");

}

std::uint64_t Redmine::Issue::getId() const 
{
    return data_["id"].get<std::uint64_t>();
}

std::string Redmine::Issue::getProject() const
{
    return data_["project"]["name"].get<std::string>();
}

std::uint64_t Redmine::Issue::getProjectId() const
{
    return data_["project"]["id"].get<std::uint64_t>();
}

std::string Redmine::Issue::getStatus() const
{
    return data_["status"]["name"].get<std::string>();
}

std::uint64_t Redmine::Issue::getStatusID() const
{
    return data_["status"]["id"].get<std::uint64_t>();
}

std::string Redmine::Issue::getSubject() const
{
    return data_["subject"].get<std::string>();
}

std::string Redmine::Issue::getDescription() const
{
    return data_["description"].get<std::string>();
}


std::string Redmine::Issue::to_string() const 
{
    return data_.dump(2);
}