/* 
* Copyright (C) 2024 Dominik Meyer
*  
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*  
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*  
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include <Redmine/IssueStatus.hpp>
#include <sstream>

void Redmine::IssueStatus::_verify(const nlohmann::json &data)
{
    _baseVerify(data,"");

}


void Redmine::IssueStatus::set(const nlohmann::json &data)
{
    _verify(data);
    data_=data;
}

Redmine::IssueStatus::IssueStatus(const nlohmann::json &status)
{
    set(status);
}

nlohmann::json Redmine::IssueStatus::get() const
{
    return data_;
}

std::string Redmine::IssueStatus::getName() const
{
    return data_["name"].get<std::string>();
}

std::uint64_t Redmine::IssueStatus::getId() const 
{
    return data_["id"].get<std::uint64_t>();
}

bool Redmine::IssueStatus::isClosed() const 
{
    return data_["is_closed"].get<bool>();
}

std::string Redmine::IssueStatus::to_string() const 
{
    std::stringstream strStream;

    strStream << getName() << "( ID=" << getId() << ", closesIssue=" << isClosed() << ")";

    return strStream.str();
}