#include <Redmine/Project.hpp>
#define LOGURU_WITH_STREAMS 1
#include <loguru.hpp>


Redmine::Project::Project(const nlohmann::json &project) : Redmine::Object()
{
    set(project);
}

void Redmine::Project::set(const nlohmann::json &data)
{
    _verify(data);
    data_=data;
}

nlohmann::json Redmine::Project::get() const 
{
    return data_;
}

void Redmine::Project::_verify(const nlohmann::json &data)
{
    
    _baseVerify(data, "");

}

std::uint64_t Redmine::Project::getId() const 
{
    return data_["id"].get<std::uint64_t>();
}

std::string Redmine::Project::getName() const
{
    return data_["name"].get<std::string>();
}

std::string Redmine::Project::getStringID() const
{
    return data_["identifier"].get<std::string>();
}

std::string Redmine::Project::to_string() const 
{
    return data_.dump(2);
}